"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var CfReceiverService = /** @class */ (function () {
    function CfReceiverService(config) {
        this.config = config;
        console.log('starting CfReceiverService');
    }
    /**
     * open connection to the WebSocket end point
     */
    CfReceiverService.prototype.watch = function () {
        var _this = this;
        return new rxjs_1.Observable(function (obser) {
            console.log("watch for data from  ws://" + _this.config.endPoint + "/" + _this.config.workflowID);
            _this.connect(obser);
        });
    };
    CfReceiverService.prototype.connect = function (obser) {
        var _this = this;
        console.log('connecting to WebSocket');
        this.ws = new WebSocket("ws://" + this.config.endPoint + "/" + this.config.workflowID);
        this.ws.onerror = function (event) {
            obser.next({
                type: 'error',
                event: event
            });
            _this.retry(obser);
        };
        this.ws.onclose = function (event) {
            obser.next({
                type: 'close',
                event: event
            });
        };
        this.ws.onmessage = function (event) {
            obser.next({
                type: 'message',
                event: event
            });
        };
    };
    CfReceiverService.prototype.retry = function (obser) {
        var _this = this;
        console.log('try to reconnect to WebSocket');
        setTimeout(function () {
            _this.connect(obser);
        }, this.config.reconnectDelay);
    };
    return CfReceiverService;
}());
exports.CfReceiverService = CfReceiverService;
//# sourceMappingURL=cfReceiver.service.js.map